"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Checkbox_exports = {};
__export(Checkbox_exports, {
  Checkbox: () => Checkbox
});
module.exports = __toCommonJS(Checkbox_exports);
var import_jkl_react_hooks = require("@fremtind/jkl-react-hooks");
var import_classnames = __toESM(require("classnames"));
var import_react = __toESM(require("react"));
const Checkbox = (0, import_react.forwardRef)(
  (props, ref) => {
    const _a = props, {
      id,
      children,
      invalid,
      className,
      inline = false,
      density,
      "data-testautoid": testAutoId,
      checked,
      indeterminate
    } = _a, rest = __objRest(_a, [
      "id",
      "children",
      "invalid",
      "className",
      "inline",
      "density",
      "data-testautoid",
      "checked",
      "indeterminate"
    ]);
    const inputRef = (0, import_react.useRef)(null);
    (0, import_react.useImperativeHandle)(ref, () => inputRef.current, []);
    const inputId = (0, import_jkl_react_hooks.useId)(id || "jkl-checkbox", { generateSuffix: !id });
    (0, import_react.useEffect)(() => {
      if (checked === true && indeterminate === true && true) {
        console.warn(
          "A Checkbox can not be both checked and indeterminate, and will be treated as checked"
        );
      }
      if (inputRef.current) {
        inputRef.current.indeterminate = !checked && !!indeterminate;
      }
    }, [checked, indeterminate]);
    return /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        className: (0, import_classnames.default)("jkl-checkbox", className, {
          "jkl-checkbox--inline": inline,
          "jkl-checkbox--error": invalid
        }),
        "data-density": density
      },
      /* @__PURE__ */ import_react.default.createElement(
        "input",
        __spreadValues({
          id: inputId,
          ref: inputRef,
          className: "jkl-checkbox__input",
          "data-testid": "jkl-checkbox-input",
          "aria-invalid": invalid,
          type: "checkbox",
          "data-testautoid": testAutoId,
          checked
        }, rest)
      ),
      /* @__PURE__ */ import_react.default.createElement("label", { htmlFor: inputId, className: "jkl-checkbox__label" }, /* @__PURE__ */ import_react.default.createElement("span", { className: "jkl-checkbox__mark" }, /* @__PURE__ */ import_react.default.createElement("span", { className: "jkl-checkbox__indeterminate-mark" }), /* @__PURE__ */ import_react.default.createElement("span", { className: "jkl-checkbox__check-mark" })), /* @__PURE__ */ import_react.default.createElement("span", { className: "jkl-checkbox__text" }, children))
    );
  }
);
Checkbox.displayName = "Checkbox";
//# sourceMappingURL=Checkbox.js.map
