var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import { useId } from "@fremtind/jkl-react-hooks";
import cn from "classnames";
import React, {
  forwardRef,
  useEffect,
  useImperativeHandle,
  useRef
} from "react";
const Checkbox = forwardRef(
  (props, ref) => {
    const _a = props, {
      id,
      children,
      invalid,
      className,
      inline = false,
      density,
      "data-testautoid": testAutoId,
      checked,
      indeterminate
    } = _a, rest = __objRest(_a, [
      "id",
      "children",
      "invalid",
      "className",
      "inline",
      "density",
      "data-testautoid",
      "checked",
      "indeterminate"
    ]);
    const inputRef = useRef(null);
    useImperativeHandle(ref, () => inputRef.current, []);
    const inputId = useId(id || "jkl-checkbox", { generateSuffix: !id });
    useEffect(() => {
      if (checked === true && indeterminate === true && true) {
        console.warn(
          "A Checkbox can not be both checked and indeterminate, and will be treated as checked"
        );
      }
      if (inputRef.current) {
        inputRef.current.indeterminate = !checked && !!indeterminate;
      }
    }, [checked, indeterminate]);
    return /* @__PURE__ */ React.createElement(
      "div",
      {
        className: cn("jkl-checkbox", className, {
          "jkl-checkbox--inline": inline,
          "jkl-checkbox--error": invalid
        }),
        "data-density": density
      },
      /* @__PURE__ */ React.createElement(
        "input",
        __spreadValues({
          id: inputId,
          ref: inputRef,
          className: "jkl-checkbox__input",
          "data-testid": "jkl-checkbox-input",
          "aria-invalid": invalid,
          type: "checkbox",
          "data-testautoid": testAutoId,
          checked
        }, rest)
      ),
      /* @__PURE__ */ React.createElement("label", { htmlFor: inputId, className: "jkl-checkbox__label" }, /* @__PURE__ */ React.createElement("span", { className: "jkl-checkbox__mark" }, /* @__PURE__ */ React.createElement("span", { className: "jkl-checkbox__indeterminate-mark" }), /* @__PURE__ */ React.createElement("span", { className: "jkl-checkbox__check-mark" })), /* @__PURE__ */ React.createElement("span", { className: "jkl-checkbox__text" }, children))
    );
  }
);
Checkbox.displayName = "Checkbox";
export {
  Checkbox
};
//# sourceMappingURL=Checkbox.js.map
